#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sched.h>
#include <sys/soundcard.h>

#include "../../m6502.h"
#include "../../fce.h"
#include "../../svga.h"
#include "../../mapper.h"
#include "../../sound.h"

extern byte vretrace;
static int dspfd,threadpid;
static void __dsploop(void);

static int __opensound(int rate)
{
 int x,y;

 printf("  Opening /dev/dsp...");
 dspfd=open("/dev/dsp",O_SYNC|O_WRONLY);
 if(dspfd==-1) goto __disperror;

 x=AFMT_U8;
 printf("\n   Setting format to 8-bit, unsigned...");
 if(ioctl(dspfd,SNDCTL_DSP_SETFMT,&x)==-1) goto __disperror;
 x=0;
 printf("\n   Setting mono sound...");  
 if(ioctl(dspfd,SNDCTL_DSP_STEREO,&x)==-1) goto __disperror;
 printf("\n   Setting playback rate of %d hz...",rate);
 if(ioctl(dspfd,SNDCTL_DSP_SPEED,&rate)==-1) goto __disperror;
 printf("Set to %d hz\n",rate);
 x=y=8|(8<<16);
 printf("   Setting fragment size to 256 and number of fragments to 8...\n");
 if(ioctl(dspfd,SNDCTL_DSP_SETFRAGMENT,&x)==-1) goto __disperror;
 if((x&0xFFFF)!=(y&0xFFFF)) goto __disperror;

 return rate;
 __disperror:
 printf("ERROR\n");
 return 0;
}
static long ZK;
static long ZL;
static byte stackspace[4096];
static int waitsigs;
int InitSound(void)
{
 int rate=48000;
 int *t=&waitsigs;
 waitsigs=0;
 if(!(rate=__opensound(rate))) return 0;
 if((threadpid=__clone((void*)__dsploop,&stackspace[4095],CLONE_VM,""))==-1)
  {close(dspfd);return 0;}
 ZK=((unsigned long)0x2000000*(PAL?50:(long double)60.098478)/(rate/256));
 ZL=0;
 sigl:
 if(!*t) goto sigl;
 return rate;
}

void TrashSound(void)
{
 if(threadpid!=-1) kill(threadpid,SIGTERM);
 threadpid=-1;
}

byte Buf[256];

static void __closedsp()
{
 close(dspfd);
 exit(0);
}

static void __dsploop(void)
{
   /* Reset signal handlers for this thread to default. */
   signal(SIGSEGV,SIG_DFL);
   signal(SIGTERM,(void *)__closedsp);
   signal(SIGINT,SIG_DFL);
   signal(SIGFPE,SIG_DFL);
   waitsigs=1;
   for(;;)
   {
     FillSoundBuffer(Buf);
     if((vmode==3 || vmode==6) || ssync)
       {
        ZL+=ZK;
        if(ZL>=0x2000000)
        {
          ZL-=0x2000000;
          if(vretrace<4) vretrace++;
        }
       }
       write(dspfd,Buf,256);
   }
}
